# Thoughts on signing the WorldWideWeb.app code in 2021

As people seemed to appreciate autographed versions of books, now we have NFT technology, I thought it could be fun to make an autographed copy of the original code of the first web browser.

I was very lucky, back in 1990, to be allowed some time to sit and code. Thanks to a boss, Mike Sendall, who understood my excitement at the new system I wanted to build and let me do it as a quite unofficial project. He knew I wanted to try out the NeXT machine – the new cool black PC that was also a unix workstation from Steve Job’s company when he split from Apple. So for me as a physicist-turned software engineer this was going to fun on two counts – fun to try out the NeXT, and especially, fun to have space to make this global internet-based hypertext system. The development system on the NeXT in fact would make it easy.

I fired up the cube - the famous 12” magnesium cube – maybe the Harley Davidson of computers - and found one of the tools, InterfaceBuilder.app. IIRC. When I made a new project I had to choose a name for it so I typed in `WorldWideWeb.app`. It gave me some basic skeleton apps for the NeXT machine, with a File Menu and an Edit menu straight away. Then I could add new menus to the project, and dialog boxes and so on, by just dragging things around, but then I had to write the core code to the app. I didn’t have to write code for that – only for the things which make my app different from other apps. The language of choice was Objective-C – a new one for me but pretty like others I’d used.

The files are in the folder `WWWNeXTStepEditor/WWW/NeXT/Implementation/` The code you see in this artwork are mainly Object-C files with the `.m` extension. There were also header files with `.h` extension but the workings of the next browser was in the `.m`s.

I’ve told the story of Mike Sendall letting me write the code a thousand times it seems, but I honestly can’t remember a time when I have actually gone back and looked at the code until now. And while it was a lot of years ago, it looks very like code I’d write today. And in fact you can make new iPhone apps using Apple’s Interface Builder (when I last checked) which is a descendent of the one I was using then, and you can write in Objective-C.

The design of the web is basically three new specs I wrote in my head as I wrote this code.

The Universal Document Identifier, which we now call a URI or URL, is in a way the key. Every document on the web has to have one of these names which starts typically with ‘http:’ The code which deals with URIs is in `HTParse.c`

The other parts were the network protocol, Hypertext Transfer Protocol (HTTP), and the format for hypertext pages, Hypertext Markup Language, HTML.

The file `HyperText.m` is where I made a window on the screen with text with links. There is a lot about “anchors”. In hypertext terminology, an anchor is the thing you can click on to follow a link. So there is code to allow you to highlight something and mark it as a target of a link, or make it a link to another anchor you marked. Remember this was a hypertext editor, you could express your thoughts and link them all together however you liked.

The code for talking to other computers on the network is in the file HTTP. I designed a new protocol, the Hypertext Transfer Protocol, partly to be really simple. The code in `HTTP.c` to get a file over the internet is just 126 lines. So lots of people would be able to write their own code to do that in their own apps.

The file `FileAccess.m` has the code which loads and saves files to local computer files. Note the network code in `HTTP.c` will only get content from a web server, not save it back. If you wanted to edit it you had to do that in the files on your computer, and then sync them with the files of a computer running a web server program. In the early days, those were actually the same NeXT machine.

At that time you could not directly edit content of a website. HTTP – the network protocol - does have a "PUT" as well as a “GET" operation, but I didn’t code it up. Partly from lack of time. Partly because if you are really going to allow people to all edit the same web of hypertext, you can’t let anyone update it. You need concepts of identity and access control as most things we work with are not public, or even if they end up public, they start off with limited distribution – and certainly limited ability to edit. The project I’m working on now, Solid, includes adding in those parts, web standards for identity “single sign on” and for access control. The code you see here was a start, but we are not finished!

It has been fun to go back and look over the code. It is amazing to see the things that those relatively few lines of code, with a help of an amazing growing gang of collaborators across the planet, stayed enough on track to become what the web is now. I have never once felt I could relax and sit back -- as the web was and is constantly changing. It is not yet the best it can be: there is always work to be done!

Tim Berners-Lee
2021
